/*
 * WKBPolygon.java
 *
 * Created on February 1, 2001, 4:42 PM
 */

package uk.ac.leeds.ccg.simplefeature;

import java.io.*;
/**
 *
 * @author  jamesm
 * @version 
 */
public class WKBPolygon extends Object implements Geometry{
	private final static boolean DEBUG=true;
	Tuple2 rings[][];
    int partCount;

    /** Creates new WKBPolygon */
	public WKBPolygon(DataInput in) throws IOException {
		if(DEBUG)System.out.println("---->uk.ac.leeds.ccg.simplefeature.WKBPolygon constructed. will identify itself as WPy->");
		if(DEBUG)System.out.println("WPy->Polygon Feature");
		partCount = in.readInt();
		if(DEBUG)System.out.println("WPy->It has "+partCount+" rings");

		rings = new Tuple2[partCount][];
		for(int i=0;i<partCount;i++){
			int points = in.readInt();
			rings[i]=new Tuple2[points];
			if(DEBUG)System.out.println("WPy->Ring "+i+" has "+points+" points");
			for(int j=0;j<points;j++){
				rings[i][j] = new Tuple2(in.readDouble(),in.readDouble());
			}
		}
	}

    public Tuple2[][] getParts(){
        return rings;
    }

    public int getPartCount() {
        return partCount;
    }
    
    public int getGeometryType() {
        return wkbPolygon;
    }
    
}
